/* LogiGraf.c - A.A.Shabarshin  02-DEC-2017 */
/* 03-DEC-2017 added text labels and splitters */
/* 04-DEC-2017 added support for NEDONAND */
/* 07-DEC-2017 more gates and adaptation to Turbo-C */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <graphics.h>
#include <conio.h>

int main(int argc, char** argv)
{
 FILE *f;
 char filename[100];
 char circuit[32];
 char blank[1] = "";
 char str[256] = "";
 char ss[8] = "";
 char *po;
 char *poo;
 int found = 0;
 int gd,gm,gr=0,wr=0,xmax=0,ymax=0;
 int sp_facing = 0;
 int sp_fanout = 0;
 int sp_legacy = 0;
 int sp_mirror = 0;
 int pull = 0;
 int finv = 0;
 long x0,y0,x1,y1,x2,y2;
 x0 = y0 = x1 = y1 = 0;
 *circuit = 0;
 if(argc<2)
 {
    printf("\nUsage:\n\tlogigraf filename.circ [circuit]\n\n");
    return -1;
 }
 strcpy(filename,argv[1]);
 if(argc>2) strcpy(circuit,argv[2]);
 printf("Load \"%s\"\n",filename);

while(1)
{
 found = 0;
 f = fopen(filename,"r");
 if(f==NULL) return -2;
 while(1)
 {
   fgets(str,256,f);
   str[255] = 0;
   if(feof(f)) break;
   po = strrchr(str,'\n');
   if(po!=NULL) *po = 0;
   if(found && (strstr(str,"<wire")!=NULL || strstr(str,"<comp")!=NULL || strstr(str,"</circuit")!=NULL))
   {
      if(ss[0]=='S' && ss[1]==0)
      {
        /* we have unpopulated Splitter! */
        *ss = 0;
        if(x1>=0 && x1<=xmax && y1>=0 && y1<ymax)
        {
          if(sp_facing=='n' && !sp_legacy && sp_mirror)
          {
            line(x1,y1,x1+20,y1-20);
            line(x1+10,y1-10,x1+10,y1-20);
            line(x1+10,y1-13,x1+13,y1-13);
            sp_fanout-=2;
            x2 = x1+30;
            while(--sp_fanout>=0)
            {
              line(x1+10,y1-10,x2,y1-20);
              x2+=10;
            }
          }
          if(sp_facing=='e' && !sp_legacy && !sp_mirror)
          {
            line(x1,y1,x1+20,y1-20);
            line(x1+10,y1-10,x1+20,y1-10);
            line(x1+13,y1-10,x1+13,y1-13);
            sp_fanout-=2;
            y2 = y1-30;
            while(--sp_fanout>=0)
            {
              line(x1+10,y1-10,x1+20,y2);
              y2-=10;
            }
          }
          if(sp_facing=='e' && !sp_legacy && sp_mirror)
          {
            line(x1,y1,x1+20,y1+20);
            line(x1+10,y1+10,x1+20,y1+10);
            line(x1+13,y1+10,x1+13,y1+13);
            sp_fanout-=2;
            y2 = y1+30;
            while(--sp_fanout>=0)
            {
              line(x1+10,y1+10,x1+20,y2);
              y2+=10;
            }
          }
          if(sp_facing=='w' && !sp_legacy && !sp_mirror)
          {
            line(x1,y1,x1-20,y1+20);
            line(x1-10,y1+10,x1-20,y1+10);
            line(x1-13,y1+10,x1-13,y1+13);
            sp_fanout-=2;
            y2 = y1+30;
            while(--sp_fanout>=0)
            {
              line(x1-10,y1+10,x1-20,y2);
              y2+=10;
            }
          }
          if(sp_facing=='w' && !sp_legacy && sp_mirror)
          {
            line(x1,y1,x1-20,y1-20);
            line(x1-10,y1-10,x1-20,y1-10);
            line(x1-13,y1-10,x1-13,y1-13);
            sp_fanout-=2;
            y2 = y1-30;
            while(--sp_fanout>=0)
            {
              line(x1-10,y1-10,x1-20,y2);
              y2-=10;
            }
          }
          if(sp_facing=='w' && sp_legacy && sp_fanout==2)
          {
            line(x1,y1,x1-10,y1-10);
            line(x1-10,y1-10,x1-20,y1-10);
            line(x1-10,y1-10,x1-20,y1);
            line(x1-13,y1-10,x1-13,y1-7);
          }
        }
      }
      if(ss[0]=='R' && ss[1]==0)
      {
        /* we have unpopulated Pull Resistor! */
        if(x1>=0 && x1<=xmax && y1>=0 && y1<ymax)
        {
           line(x1,y1,x1,y1-5);
           line(x1-5,y1-5,x1+5,y1-5);
           line(x1-5,y1-5,x1-5,y1-25);
           line(x1+5,y1-5,x1+5,y1-25);
           line(x1-5,y1-25,x1+5,y1-25);
           line(x1,y1-25,x1,y1-30);
           sprintf(ss,"%i",pull);
           outtextxy(x1-4,y1-38,ss);
        }
        *ss = 0;
      }
   }
   if(!found && strstr(str,"<circuit")!=NULL)
   {
     if(*circuit==0)
     {
         printf("%s\n",str);
     }
     else
     {
         po = strstr(str,"name=");
         if(po!=NULL)
         {
            po = &po[6];
            poo = strchr(po,'"');
            if(poo!=NULL) *poo=0;
            if(strcmp(po,circuit)) continue;
            found = 1;
            if(!gr)
            {
             printf("Found: \"%s\"\n",po);
#if 1
             registerfarbgidriver(EGAVGA_driver);
#endif
             gd=EGA;gm=EGAHI;
             initgraph(&gd,&gm,"");
             xmax = getmaxx();
             ymax = getmaxy();
             setcolor(0);
             setfillstyle(SOLID_FILL,15);
             bar(0,0,xmax,ymax);
             gr = 1;
            }
         }
     }
   }
   else if(strstr(str,"<wire")!=NULL)
   {
      if(found)
      {
        po = strstr(str," from=");
        if(po!=NULL)
        {
          po = &po[8];
          x1 = atol(po)-x0;
          poo = strchr(po,',');
          if(poo!=NULL)
          {
            poo++;
            y1 = atol(poo)-y0;
            po = strstr(str," to=");
            if(po!=NULL)
            {
              po = &po[6];
              x2 = atol(po)-x0;
              poo = strchr(po,',');
              if(poo!=NULL)
              {
                poo++;
                y2 = atol(poo)-y0;

                if(x1<xmax && y1<ymax && x2>=0 && y2>=0)
                {
                   setfillstyle(SOLID_FILL,0);
                   if(x1 > 0 && x1 < xmax && y1 > 0 && y1 < ymax)
                   {
                      if(getpixel(x1,y1)==0)
                      {
                         wr = 0;
                         if(getpixel(x1-1,y1)==0) wr++;
                         if(getpixel(x1+1,y1)==0) wr++;
                         if(getpixel(x1,y1-1)==0) wr++;
                         if(getpixel(x1,y1+1)==0) wr++;
                         if(wr>1) fillellipse(x1,y1,2,2);
                      }
                   }
                   if(x2 > 0 && x2 < xmax && y2 > 0 && y2 < ymax)
                   {
                      if(getpixel(x2,y2)==0)
                      {
                         wr = 0;
                         if(getpixel(x2-1,y2)==0) wr++;
                         if(getpixel(x2+1,y2)==0) wr++;
                         if(getpixel(x2,y2-1)==0) wr++;
                         if(getpixel(x2,y2+1)==0) wr++;
                         if(wr>1) fillellipse(x2,y2,2,2);
                      }
                   }
                   if(x1 < 0) x1=0;
                   if(y1 < 0) y1=0;
                   if(x2 > xmax) x2=xmax;
                   if(y2 > ymax) y2=ymax;
                   line(x1,y1,x2,y2);
                }
              }
            }
          }
        }
      }
   }
   else if(strstr(str,"<comp")!=NULL)
   {
     if(found)
     {
      x1 = y1 = -1;
      *ss = 0;
      po = strstr(str," loc=");
      if(po!=NULL)
      {
        po = &po[7];
        x1 = atol(po)-x0;
        poo = strchr(po,',');
        if(poo!=NULL)
        {
          poo++;
          y1 = atol(poo)-y0;
        }
      }
      finv = 0;
      if(strstr(str,"name=\"Button\"")!=NULL)
      {
        x1 -= 10;
        y1 -= 5;
        x2 = x1 + 10;
        y2 = y1 + 10;
        strcpy(ss," ");
      }
      else if(strstr(str,"name=\"Constant\"")!=NULL)
      {
        x1 -= 10;
        y1 -= 5;
        x2 = x1 + 10;
        y2 = y1 + 10;
        strcpy(ss,"0");
      }
      else if(strstr(str,"name=\"n\"")!=NULL)
      {
        x1 -= 10;
        y1 -= 5;
        x2 = x1 + 10;
        y2 = y1 + 10;
        strcpy(ss,"N");
      }
      else if(strstr(str,"name=\"o\"")!=NULL)
      {
        x1 -= 10;
        y1 -= 5;
        x2 = x1 + 10;
        y2 = y1 + 10;
        strcpy(ss,"O");
      }
      else if(strstr(str,"name=\"p\"")!=NULL)
      {
        x1 -= 10;
        y1 -= 5;
        x2 = x1 + 10;
        y2 = y1 + 10;
        strcpy(ss,"P");
      }
      else if(strstr(str,"name=\"clk\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 5;
        x2 = x1 + 30;
        y2 = y1 + 10;
        strcpy(ss,"CLK");
      }
      else if(strstr(str,"name=\"not\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 5;
        x2 = x1 + 30;
        y2 = y1 + 10;
        strcpy(ss,"NOT");
      }
      else if(strstr(str,"name=\"bln\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 5;
        x2 = x1 + 30;
        y2 = y1 + 10;
        strcpy(ss,"BLN");
      }
      else if(strstr(str,"name=\"blp\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 5;
        x2 = x1 + 30;
        y2 = y1 + 10;
        strcpy(ss,"BLP");
      }
      else if(strstr(str,"name=\"e12\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 5;
        x2 = x1 + 30;
        y2 = y1 + 30;
        strcpy(ss,"E12");
      }
      else if(strstr(str,"name=\"e21\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 5;
        x2 = x1 + 30;
        y2 = y1 + 30;
        strcpy(ss,"E21");
      }
      else if(strstr(str,"name=\"dmux\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 5;
        x2 = x1 + 30;
        y2 = y1 + 40;
        strcpy(ss,"DMX");
      }
      else if(strstr(str,"name=\"mux\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 5;
        x2 = x1 + 30;
        y2 = y1 + 40;
        strcpy(ss,"MUX");
      }
      else if(strstr(str,"name=\"mem\"")!=NULL)
      {
        x1 -= 40;
        y1 -= 5;
        x2 = x1 + 40;
        y2 = y1 + 30;
        strcpy(ss,"MEM");
      }
      else if(strstr(str,"name=\"max\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 5;
        x2 = x1 + 30;
        y2 = y1 + 20;
        strcpy(ss,"MAX");
      }
      else if(strstr(str,"name=\"min\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 5;
        x2 = x1 + 30;
        y2 = y1 + 20;
        strcpy(ss,"MIN");
      }
      else if(strstr(str,"name=\"HalfAdder\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 5;
        x2 = x1 + 30;
        y2 = y1 + 20;
        strcpy(ss,"H.A");
      }
      else if(strstr(str,"name=\"halfadder\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 5;
        x2 = x1 + 30;
        y2 = y1 + 20;
        strcpy(ss,"HA2");
      }
      else if(strstr(str,"name=\"xor\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 15;
        x2 = x1 + 30;
        y2 = y1 + 30;
        strcpy(ss,"XOR");
      }
      else if(strstr(str,"name=\"and9\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 45;
        x2 = x1 + 30;
        y2 = y1 + 90;
        strcpy(ss,"&");
      }
      else if(strstr(str,"name=\"alu\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 15;
        x2 = x1 + 30;
        y2 = y1 + 120;
        strcpy(ss,"ALU");
      }
      else if(strstr(str,"name=\"dmux8\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 5;
        x2 = x1 + 30;
        y2 = y1 + 80;
        strcpy(ss,"DM8");
      }
      else if(strstr(str,"name=\"Multiplexer\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 15;
        x2 = x1 + 30;
        y2 = y1 + 35;
        strcpy(ss,"MX");
      }
      else if(strstr(str,"name=\"Register\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 20;
        x2 = x1 + 30;
        y2 = y1 + 40;
        strcpy(ss,"REG");
      }
      else if(strstr(str,"name=\"D Flip-Flop\"")!=NULL)
      {
        x1 -= 40;
        y1 -= 10;
        x2 = x1 + 40;
        y2 = y1 + 40;
        strcpy(ss,"Dtrg");
      }
      else if(strstr(str,"name=\"S-R Flip-Flop\"")!=NULL)
      {
        x1 -= 40;
        y1 -= 10;
        x2 = x1 + 40;
        y2 = y1 + 40;
        strcpy(ss,"SR");
      }
      else if(strstr(str,"name=\"AND Gate\"")!=NULL)
      {
        x1 -= 50;
        y1 -= 25;
        x2 = x1 + 40;
        y2 = y1 + 50;
        strcpy(ss,"&");
        finv = -1;
      }
      else if(strstr(str,"name=\"OR Gate\"")!=NULL)
      {
        x1 -= 50;
        y1 -= 25;
        x2 = x1 + 40;
        y2 = y1 + 50;
        strcpy(ss,"1");
        finv = -1;
      }
      else if(strstr(str,"name=\"XOR Gate\"")!=NULL)
      {
        x1 -= 60;
        y1 -= 25;
        x2 = x1 + 40;
        y2 = y1 + 50;
        strcpy(ss,"=1");
        finv = -2;
      }
      else if(strstr(str,"name=\"NAND Gate\"")!=NULL)
      {
        x1 -= 60;
        y1 -= 25;
        x2 = x1 + 40;
        y2 = y1 + 50;
        strcpy(ss,"&");
        finv = 2;
      }
      else if(strstr(str,"name=\"NOR Gate\"")!=NULL)
      {
        x1 -= 60;
        y1 -= 25;
        x2 = x1 + 40;
        y2 = y1 + 50;
        strcpy(ss,"1");
        finv = 2;
      }
      else if(strstr(str,"name=\"XNOR Gate\"")!=NULL)
      {
        x1 -= 70;
        y1 -= 25;
        x2 = x1 + 40;
        y2 = y1 + 50;
        strcpy(ss,"=1");
        finv = 3;
      }
      else if(strstr(str,"name=\"NOT Gate\"")!=NULL)
      {
        x1 -= 30;
        y1 -= 5;
        x2 = x1 + 20;
        y2 = y1 + 10;
        strcpy(ss,"1");
        finv = 1;
      }
      else if(strstr(str,"name=\"triada7seg")!=NULL)
      {
        x1 -= 30;
        y1 -= 5;
        x2 = x1 + 30;
        y2 = y1 + 80;
        strcpy(ss,"7SG");
      }
      else if(strstr(str,"name=\"7-Segment")!=NULL || strstr(str,"name=\"Hex Digit")!=NULL)
      {
        if(strstr(str,"Hex")!=NULL){x1-=10;y1-=60;}
        x1 -= 5;
        x2 = x1 + 40;
        y2 = y1 + 60;
        strcpy(ss,"");
        line(x1+10,y1+10,x2-10,y1+10);
        line(x1+10,y1+30,x2-10,y1+30);
        line(x1+10,y2-10,x2-10,y2-10);
        line(x1+8,y1+12,x1+8,y1+28);
        line(x1+8,y1+32,x1+8,y1+48);
        line(x2-8,y1+12,x2-8,y1+28);
        line(x2-8,y1+32,x2-8,y1+48);
      }
      else if(strstr(str,"name=\"ROM\"")!=NULL)
      {
        x1 -= 140;
        y1 -= 35;
        x2 = x1 + 140;
        y2 = y1 + 70;
        strcpy(ss,"ROM");
      }
      else if(strstr(str,"name=\"Text\"")!=NULL)
      {
        x2 = y2 = -1;
        strcpy(ss,"T");
      }
      else if(strstr(str,"name=\"Splitter\"")!=NULL)
      {
        x2 = y2 = -1;
        strcpy(ss,"S");
        sp_facing = 'e';
        sp_fanout = 2;
        sp_legacy = 0;
        sp_mirror = 0;
      }
      else if(strstr(str,"name=\"Pull Resistor\"")!=NULL)
      {
        x2 = y2 = -1;
        strcpy(ss,"R");
        pull = 0;
      }
      else if(strstr(str,"name=\"Ground\"")!=NULL)
      {
        x2 = y2 = -1;
        *ss = 0;
        line(x1,y1,x1,y1+5);
        line(x1-5,y1+5,x1+5,y1+5);
      }
      else
      {
        if(x1>=0 && x1<=xmax && y1>=0 && y1<=ymax)
        {
           circle(x1,y1,5);
        }
        x1 = y1 = -1;
      }
      if(x1>=0 && x1<=xmax && y1>=0 && y1<=ymax &&
         x2>=0 && x2<=xmax && y2>=0 && y2<=ymax)
      {
        rectangle(x1,y1,x2,y2);
        outtextxy(x1+2,y1+2,ss);
        switch(finv)
        {
          case -2:
            line(x1+40,y1+25,x1+60,y1+25);
            break;
          case -1:
            line(x1+40,y1+25,x1+50,y1+25);
            break;
          case 1:
            circle(x1+20,y1+5,4);
            line(x1+24,y1+5,x1+30,y1+5);
            setcolor(15);
            line(x1+20,y1+3,x1+20,y1+7);
            setcolor(0);
            break;
          case 2:
            circle(x1+40,y1+25,4);
            line(x1+44,y1+25,x1+60,y1+25);
            setcolor(15);
            line(x1+40,y1+23,x1+40,y1+27);
            setcolor(0);
            break;
          case 3:
            circle(x1+40,y1+25,4);
            line(x1+44,y1+25,x1+70,y1+25);
            setcolor(15);
            line(x1+40,y1+23,x1+40,y1+27);
            setcolor(0);
            break;
        }
      }
     }
   }
   else if(strstr(str,"<a name")!=NULL)
   {
        po = strstr(str," val=");
        if(po==NULL) po=blank;
        else
        {
          po = &po[6];
          poo = strchr(po,'"');
          if(poo!=NULL) *poo=0;
        }
        if(strstr(str,"<a name=\"label\"")!=NULL && ss[0]=='R' && ss[1]=='E' && ss[2]=='G')
        {
           if(x1>=0 && x1<=xmax && y1>=0 && y1<=ymax)
           {
              outtextxy(x1-8,y1-8,po);
           }
        }
        if(strstr(str,"<a name=\"label\"")!=NULL && ss[0]=='D' && ss[1]=='t' && ss[2]=='r')
        {
           if(x1>=0 && x1<=xmax && y1>=0 && y1<=ymax)
           {
              outtextxy(x1-8,y1-8,po);
           }
        }
        if(strstr(str,"<a name=\"label\"")!=NULL && ss[0]==' ' && ss[1]==0)
        {  /* Button */
           if(x1>=0 && x1<=xmax && y1>=0 && y1<=ymax)
           {
              line(x1-1,y1-1,x1-1,y2-1);
              line(x1-1,y1-1,x2-1,y1-1);
              po[1] = 0; /* 1st character only */
              outtextxy(x1+2,y1+2,po);
           }
        }
        if(strstr(str,"<a name=\"text\"")!=NULL && ss[0]=='T' && ss[1]==0)
        {
           if(x1>=0 && x1<=xmax && y1>=0 && y1<=ymax)
              outtextxy(x1-strlen(po)*4+2,y1-4,po);
        }
        if(strstr(str,"<a name=\"facing\"")!=NULL && ss[0]=='S' && ss[1]==0)
        {
           sp_facing = *po;
        }
        if(strstr(str,"<a name=\"appear\"")!=NULL && ss[0]=='S' && ss[1]==0)
        {
           if(*po=='l') sp_legacy = 1;
           if(*po=='r') sp_mirror = 1;
        }
        if(strstr(str,"<a name=\"fanout\"")!=NULL && ss[0]=='S' && ss[1]==0)
        {
           sp_fanout = atoi(po);
        }
        if(strstr(str,"<a name=\"pull\"")!=NULL && ss[0]=='R' && ss[1]==0)
        {
           pull = atoi(po);
        }
        if(strstr(str,"<a name=\"select\"")!=NULL && ss[0]=='M' && ss[1]=='X')
        {
           if(x1>=0 && x1<=xmax && y1>=0 && y1<=ymax)
           {
            switch(atoi(po))
            {
             case 3: /* 8 inputs */
               rectangle(x1-10,y1-30,x1+30,y1+55);
               break;
            }
           }
        }
        if(strstr(str,"<a name=\"contents\"")!=NULL && ss[0]=='R' && ss[1]=='O' && ss[2]=='M' && ss[3]==0)
        {
           if(x1>=0 && x1<=xmax && y1>=0 && y1<=ymax)
           {
              po = strstr(str,"addr");
              if(po!=NULL) outtextxy(x1+10,y1+32,po);
           }
        }
   }
   else if(strstr(str,"</circuit")!=NULL)
   {
      if(found) break;
   }
 }
 fclose(f);
 if(found)
 {
   wr = getch();
   if(wr==27) break;
   setfillstyle(SOLID_FILL,15);
   bar(0,0,xmax,ymax);
   if(wr==0)
   {
      switch(getch())
      {
        case 75: /* left */
          if(x0>0) x0-=10;
          break;
        case 77: /* right */
          x0+=10;
          break;
        case 72: /* up */
          if(y0>0) y0-=10;
          break;
        case 80: /* down */
          y0+=10;
          break;
      }

   }
 }
 else break;
}
if(found) closegraph();
return 0;
}
